Bug 974534 - CPAN/Perl Stopped working (gear postreceive/permissions issue?)
CPAN/Perl Stopped working (gear postreceive/permissions issue?)
Status: CLOSED CURRENTRELEASE
Product: OpenShift Online
Classification: Red Hat
Component: Containers (Show other bugs)
2.x
Unspecified Unspecified
medium Severity medium
: ---
: ---
Assigned To: Jhon Honce
libra bugs
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-14 07:18 EDT by Will Foster
Modified: 2015-05-14 19:21 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-22 11:16:38 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Will Foster 2013-06-14 07:18:42 EDT
Description of problem:

Hello, I noticed in the past 24hrs that Perl/CPAN functionality stopped working.
Doing an arbitrary change so git push can force a reload I see the following error:

== snip ==
(wfoster@hobohouse) - (12:57) - (~/git_modules/pivo)
-=>>git push
Counting objects: 7, done.
Delta compression using up to 8 threads.
Compressing objects: 100% (4/4), done.
Writing objects: 100% (4/4), 395 bytes, done.
Total 4 (delta 3), reused 0 (delta 0)
remote: Waiting for stop to finish
remote: Can't write to cpanm home '/.cpanm': You should fix it with chown/chmod first.
remote: An error occurred executing 'gear postreceive'
remote: 
remote: For more details about the problem, try running the command again with the '--trace' option.
== snip ==


Version-Release number of selected component (if applicable):


How reproducible:

Everytime / not functional


Steps to Reproduce:


attempt to use perl CGI functionality or git push a change
to the gear.


Actual results:

Perl CGI fails to execute.
Also, git push does not trigger gear reload

Expected results:

CGI functionality works as before, and new git changes
will reload gear as expected.


Additional info:
Comment 1 Will Foster 2013-06-14 07:25:56 EDT
If it helps, my gear name is "pivo-tocene"

Thanks,

-will
Comment 2 Jhon Honce 2013-06-18 14:08:01 EDT
Fixed in https://github.com/openshift/origin-server/pull/2885
Comment 3 openshift-github-bot 2013-06-18 21:27:40 EDT
Commits pushed to master at https://github.com/openshift/origin-server

https://github.com/openshift/origin-server/commit/891684213142e419f9d926862fa0f42f1f999fb7
Bug 974534 - Add support for CPANMINUS_HOME

https://github.com/openshift/origin-server/commit/20145b80e29931d74e4d85bf0439d308b66bbf2c
Bug 974534 - Add support for CPANMINUS_HOME

* Update Cartridge-Version in manifest files
Comment 4 chunchen 2013-06-19 09:11:18 EDT
It's fixed, verified on devenv_3384, please refer to the following results:

1. Create a perl app
rhc app create cpl00 perl-5.10
2. Do some changes and git push
# git add .; git commit -amp; git push
[master 3a52194] p
 0 files changed
 create mode 100644 joi.txt
Counting objects: 3, done.
Delta compression using up to 4 threads.
Compressing objects: 100% (2/2), done.
Writing objects: 100% (2/2), 225 bytes, done.
Total 2 (delta 1), reused 0 (delta 0)
remote: Waiting for stop to finish
To ssh://358756401996739200942080@cpl00-ray.dev.rhcloud.com/~/git/cpl00.git/
   19774c4..3a52194  master -> master
Comment 5 chunchen 2013-06-19 23:21:53 EDT
Also please refer to the results when attempting to use CPAN or CGI, this were tested on devenv_3389.

1. For attempting to use CPAN
1) Add CPAN to deplist.txt of perl app
echo "CPAN" > deplist.txt
2) Git push this changes
git add .; git commit -amp; git push

[master 43011dc] p
 1 file changed, 1 insertion(+), 1 deletion(-)
Counting objects: 5, done.
Delta compression using up to 4 threads.
Compressing objects: 100% (2/2), done.
Writing objects: 100% (3/3), 250 bytes, done.
Total 3 (delta 1), reused 0 (delta 0)
remote: httpd (no pid file) not running
remote: --> Working on CPAN
remote: Fetching http://mirror1.ops.rhcloud.com/mirror/perl/CPAN/authors/id/A/AN/ANDK/CPAN-2.00.tar.gz ... OK
remote: Configuring CPAN-2.00 ... OK
remote: Building CPAN-2.00 ... OK
remote: Successfully installed CPAN-2.00 (upgraded from 1.9402)
remote: 1 distribution installed
To ssh://51c26bc1a36b41071f00000d@cpl02-cdm.dev.rhcloud.com/~/git/cpl02.git/
   fda77c6..43011dc  master -> master

2. For attempting to use CGI
1) Add CGI to deplist.txt of perl app
echo "CGI" > deplist.txt
2) Git push this changes
git add .; git commit -amp; git push

[master 23a28e8] p
 1 file changed, 1 insertion(+), 1 deletion(-)
Counting objects: 5, done.
Delta compression using up to 4 threads.
Compressing objects: 100% (2/2), done.
Writing objects: 100% (3/3), 249 bytes, done.
Total 3 (delta 1), reused 0 (delta 0)
remote: Waiting for stop to finish
remote: --> Working on CGI
remote: Fetching http://mirror1.ops.rhcloud.com/mirror/perl/CPAN/authors/id/M/MA/MARKSTOS/CGI.pm-3.63.tar.gz ... OK
remote: Configuring CGI.pm-3.63 ... OK
remote: ==> Found dependencies: FCGI
remote: --> Working on FCGI
remote: Fetching http://mirror1.ops.rhcloud.com/mirror/perl/CPAN/authors/id/F/FL/FLORA/FCGI-0.74.tar.gz ... OK
remote: Configuring FCGI-0.74 ... OK
remote: Building FCGI-0.74 ... OK
remote: Successfully installed FCGI-0.74
remote: Building CGI.pm-3.63 ... OK
remote: Successfully installed CGI.pm-3.63 (upgraded from 3.43)
remote: 2 distributions installed
To ssh://51c26bc1a36b41071f00000d@cpl02-cdm.dev.rhcloud.com/~/git/cpl02.git/
   43011dc..23a28e8  master -> master
Comment 6 Will Foster 2013-06-21 06:16:29 EDT
Hey there,

Thank you for the response, I've performed deplist.txt additions you recommended but still getting the same error.

-- snip --
-=>>echo "CPAN" > deplist.txt
-=>>echo "CGI" >> deplist.txt
-=>>git add deplist.txt 
-=>>git commit -amp

[master b9ba05a] p
 1 file changed, 1 insertion(+)
(wfoster@hobohouse) - (12:09) - (~/git_modules/pivo)
-=>>git push
Enter passphrase for key '/home/wfoster/.ssh/id_rsa': 
Counting objects: 5, done.
Delta compression using up to 8 threads.
Compressing objects: 100% (2/2), done.
Writing objects: 100% (3/3), 260 bytes | 0 bytes/s, done.
Total 3 (delta 1), reused 0 (delta 0)
remote: httpd (no pid file) not running
remote: Can't write to cpanm home '/.cpanm': You should fix it with chown/chmod first.
remote: An error occurred executing 'gear postreceive'
remote: 
remote: For more details about the problem, try running the command again with the '--trace' option.

-- snip --

Am I missing a step or command here?  I understand that I can probably just remake the gear, however if we can solve this in another means it might be less cumbersome for other customers that could hit this issue.

thanks,

-will
Comment 7 Will Foster 2013-06-25 11:07:04 EDT
Hey folks,

Wanted to re-open this, as it's still an issue.
prior comments (comment 6) are up to date and still reflective of
status.  Please let me know if I can provide any further information or perform
steps to help diagnose/fix.

Thanks,

-will
Comment 8 Dan McPherson 2013-06-26 14:44:32 EDT
Sorry for the confusion here.  The first for this bug will go to production with the release on July 1st.

Note You need to log in before you can comment on or make changes to this bug.